# 图片的显示与视频的播放  
## 概要
在Qt中，一般使用QLabel显示图像。视频播放，就是多张连续的图像快速的播放，超过人眼识别的速度。
一般的视频和电影是30FPS，而人眼的识别频率是24FPS，也就是每秒24张图片闪过人眼是感受不到闪烁的。
这次课程，将从以下两个方面讲述Qt图像的处理：
1. 直接显示图像。（不使用第三方图像读取，处理库）
2. 使用OpenCV读取视频并播放。

## 1.直接显示图像  
在本次的例程中，我是用Qt自带的图像读取与显示方法，大家一看程序便知。  

## 2.使用OpenCV读取视频，在Qt界面上播放  
正如之前所说，播放视频就是很快的播放连续的图片，而播放频率就靠视频的FPS控制。
使用OpenCV读取视频后，会得到视频的一系列参数，其中重要的有以下几个：  
* 视频FPS：cv2.CAP_PROP_FPS  
* 视频总帧数：cv2.CAP_PROP_FRAME_COUNT  
* 视频当前帧：cv2.CAP_PROP_POS_FRAMES  
通过简单的计算，我们可以得到视频播放的时间等信息。  

### 要点
1. 为了循环的播放一帧一帧的图像，使用了QTimer（定时器），让他定时循环溢出，
然后将溢出信号与显示一帧图像的槽程序连接。定时器的循环时间为1000/FPS，单位为毫秒。  
2. 为了实现快进，快退等功能，使用了槽连接的连接与断开，让大家更容易理解如何使用槽。
3. 在Qt中显示Mat格式的图像（OpenCV的图像格式），需要相应的转换。 

* [第六课](../Lesson_06.另一种槽连接机制/readme.md)
