# 窗口嵌套  

Qt 中几乎所有控件都是继承于 QtWidgets，所以它们之间可以相互嵌套和继承。本讲演示了两种窗口嵌套后传参的方法。   

## 第一种：指定子窗口parent  

此方法要注意以下要点，具体实现请看subwindow.py中第一种窗口示例：
1. 为了避免一些变量冲突的问题，将主窗口和子窗口的所有变量避免重复定义  
2. 子窗口调用主窗口变量，要用 self.parent().window().[控件或控件]  
3. 主窗口中初始化子窗口要指定parent为自己  
4. 主窗口直接可以调用子窗口变量  
5. 我不建议使用此方法，因为不同窗口之间的变量的耦合度太高了。

## 第二种：自定义信号  

给 QtWidgets 添加自动定义信号，通过信号来实现不同窗口之间的的通信，这种方法是我推荐的。此方法要注意
以下要点，具体实现请看subwindow.py中第二种窗口示例：  

1. 此方法不用指定parent，主窗口和子窗口是独立的
2. 子窗口中，要在def __init__ 函数之前定义信号，函数中通过[自定义信号].emit()来发出信号。
    自定义信号要指定信号类型，可以是str，int等，emit的参数类型要和信号定义的类型一致  
3. 主窗口中，初始化子窗口后要连接信号  
`TODO: 此处的信号连接使用connectSlotsByName无效？`    
4. 信号的槽函数参数和发出新信号的类型要一致  

* 下一讲([第九课](../Lesson_09.EzQtTools/readme.md))会介绍我自己定义的Qt工具，让控件设置不再繁琐。